
#version 130

uniform sampler2D textureImage;
uniform int lightNumber;
uniform int lightRecieve[7];
uniform int textureMode;
uniform int fogMode;
uniform int useTexAlpha;
uniform int dissolveMode;

in vec4 diffuseTotal;
in vec4 specularTotal;

in vec3 modelview_position;
in vec4 modelview_position4;

uniform sampler2D SM_Texture;
uniform mat4 SM_LightViewMatrix;
//uniform mat4 SM_LightProjMatrix; //KvȂB
uniform float SM_OrthoSize; //OrthoScaleKv
uniform mat4 SM_ViewMatrixInv;
uniform float SM_ProjMatrix10;
uniform float SM_ProjMatrix14;
uniform int  SM_Perspective; // -1 for not use Shadow Map
uniform int  SM_CubicMap;

uniform vec2 ensembleParamA;
uniform float ensembleParamB;
uniform vec2 ensembleParamC;

uniform float projInv11;
uniform float projInv15;

//##FUNC_SMOOTHCLIPPING##

//##FUNC_ENSEMBLE_DITHERING##

//##FUNC_FOG_EFFECT##

//##FUNC_SHADOW_MAP##

void main (void)
{
    vec4 texColor = vec4(1.0,1.0,1.0,1.0); 
    if (textureMode == 1)
	texColor = texture2D(textureImage, gl_TexCoord[0].st);

    float alpha = gl_FrontLightProduct[0].ambient[3];
    if (useTexAlpha == 1){
	alpha *= texColor[3];
	if (alpha == 0) discard;
    }

    vec4 ambientClr = vec4(0, 0, 0, 0);
    
    for (int i = 0; i < lightNumber; i++){
	if (lightRecieve[i] == 0) continue;

	ambientClr += gl_FrontLightProduct[i].ambient;
    }

    //##APPLY_SMOOTHCLIPPING##

    //##APPLY_ENSEMBLE_DITHERING##

    //if (alpha > 1.0) alpha = 1.0;
    if (alpha > 1.0){ 
	texColor[0] *= alpha;
	texColor[1] *= alpha;
	texColor[2] *= alpha; 
	alpha = 1.0;
    }

    // --- Use SHADOW Map --
    float colorFactor = 1;
    if (SM_Perspective != -1){
	//##APPLY_SHADOW_MAP##
    }


    gl_FragColor = ambientClr + 
	colorFactor * (gl_FrontMaterial.diffuse * diffuseTotal +
		       gl_FrontMaterial.specular * specularTotal);
    gl_FragColor *= texColor;
    
    FogEffect();

    gl_FragColor[3] = alpha;
}
