#version 130
//#extension GL_EXT_gpu_shader4 : enable
//#extension GL_ARB_explicit_attrib_location : enable

uniform sampler2D textureHeight;
uniform int channel;

varying vec3 positionIn;
//varying vec4 colorIn;

float GetValue(vec4 texCoordOrg){
    //vec4 texCoord = gl_TextureMatrix[0] * texCoordOrg;
    //vec4 texColor = texture2D(textureHeight, texCoord.st);
    vec4 texColor = texture2D(textureHeight, texCoordOrg.st);

    if (channel < 3)
	return texColor[channel];
    else
	return sqrt(texColor[0]*texColor[0] + texColor[1]*texColor[1] + texColor[2]*texColor[2]);
}

void main(void){
    gl_TexCoord[0] = gl_TextureMatrix[0] * gl_MultiTexCoord0;
    
    //vec4 texColor = texture2D(textureHeight, gl_TexCoord[0].st);

    float heightZ = GetValue(gl_MultiTexCoord0) * 2;

    //int width = textureSize(textureHeight, 0).x;
    //int height = textureSize(textureHeight, 0).y;
    //float dx = GetValue(gl_MultiTexCoord0+1.0/width) - GetValue(gl_MultiTexCoord0-1.0/width);
    //float dy = GetValue(gl_MultiTexCoord0+1.0/height) - GetValue(gl_MultiTexCoord0-1.0/height);
    //dx = dx/2;
    //dy = dy/2;
    
    vec4 newPos = vec4(gl_Vertex[0], gl_Vertex[1], gl_Vertex[2] * heightZ, gl_Vertex[3]);
    positionIn = vec3(gl_ModelViewMatrix * newPos);
    //colorIn = gl_Color;
    //float norm = sqrt(dx*dx + dy*dy + 1);
    //normal = gl_NormalMatrix * vec3(-dx/norm, -dy/norm, 1.0/norm) ;
    
    gl_Position = gl_ModelViewProjectionMatrix * newPos;//ftransform();
}
